using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using static Exferia_Aplicacion.General.Enumerados;
using System.Threading;
using System.Reflection;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_Configuracion_Datos : ABS_Datos
    {

        #region Listado
        
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {}
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion
        #region F3

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
        }
        #endregion

        #region Obtener
        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                                nameof(MYT_Configuracion) + "." + nameof(MYT_Configuracion.id) + " , " +
                                nameof(MYT_Configuracion) + "." + nameof(MYT_Configuracion.idParteEstado_PorDefecto) + " , " +
                                nameof(MYT_Configuracion) + "." + nameof(MYT_Configuracion.idPrioridad_PorDefecto) + " , " +
                                nameof(MYT_Configuracion) + "." + nameof(MYT_Configuracion.idParteTipo_PorDefecto) + 
                        " FROM " + nameof(MYT_Configuracion);

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MYT_Configuracion>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MYT_PartesEstados ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idParteEstado_PorDefecto != null)
                    {
                        ThreadStart obj_ThreadStart_PARTEESTADO = new ThreadStart(Obtener_ParteEstado_Modelo_Obtener);
                        Thread obj_Thread_PARTEESTADO = new Thread(obj_ThreadStart_PARTEESTADO);
                        obj_Thread_PARTEESTADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_Prioridades ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPrioridad_PorDefecto != null)
                    {
                        ThreadStart obj_ThreadStart_PRIORIDADES = new ThreadStart(Obtener_Prioridades_Modelo_Obtener);
                        Thread obj_Thread_PRIORIDADES = new Thread(obj_ThreadStart_PRIORIDADES);
                        obj_Thread_PRIORIDADES.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //MYT_PartesTipos ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idParteTipo_PorDefecto != null)
                    {
                        ThreadStart obj_ThreadStart_PARTESTIPOS = new ThreadStart(Obtener_PartesTipos_Modelo_Obtener);
                        Thread obj_Thread_PARTESTIPOS = new Thread(obj_ThreadStart_PARTESTIPOS);
                        obj_Thread_PARTESTIPOS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }


                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_ParteEstado_Modelo_Obtener()
        {
            try
            {
                MYT_PartesEstados_Datos obj_MYT_PartesEstados_Datos = new MYT_PartesEstados_Datos();
                g_dnm_Modelo_Obtener.MYT_PartesEstados = obj_MYT_PartesEstados_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idParteEstado_PorDefecto);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Prioridades_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEPRIORIDADES_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idPrioridad_PorDefecto };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Prioridades = (MAE_Prioridades)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_PartesTipos_Modelo_Obtener()
        {
            try
            {
                MYT_PartesTipos_Datos obj_MYT_PartesTipos_Datos = new MYT_PartesTipos_Datos();
                g_dnm_Modelo_Obtener.MYT_PartesTipos = obj_MYT_PartesTipos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idParteTipo_PorDefecto, false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        #endregion

        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MYT_Configuracion g_mdl_MYT_Configuracion = null;
        public MYT_Configuracion Obtener_Modelo_Por_Id(long _lng_id,
                                                        bool _bol_Cargar_PartesEstados,
                                                        bool _bol_Cargar_Prioridades,
                                                        bool _bol_Cargar_PartesTipos)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(MYT_Configuracion) + "." + nameof(MYT_Configuracion.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_PartesEstados,
                                         _bol_Cargar_Prioridades,
                                         _bol_Cargar_PartesTipos);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_Configuracion;
        }

        public MYT_Configuracion Obtener_Modelo(bool _bol_Cargar_PartesEstados,
                                                bool _bol_Cargar_Prioridades,
                                                bool _bol_Cargar_PartesTipos)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo();

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         new object[]{},
                                         _bol_Cargar_PartesEstados,
                                         _bol_Cargar_Prioridades,
                                         _bol_Cargar_PartesTipos);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Obtener_Modelo), true);
            }

            return g_mdl_MYT_Configuracion;
        }

        #region Ejecutar Consulta
        private static int g_int_TotalHilos_Modelo = 3;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros,
                                             bool _bol_Cargar_PartesEstados,
                                             bool _bol_Cargar_Prioridades,
                                             bool _bol_Cargar_PartesTipos)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_Configuracion = obj_Exferia_Entities.Database.SqlQuery<MYT_Configuracion>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_mdl_MYT_Configuracion != null)
                {
                    if (_bol_Cargar_PartesEstados ||
                        _bol_Cargar_Prioridades ||
                        _bol_Cargar_PartesTipos)
                    {
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                        }

                        //MYT_PartesEstados ##########################################################################################
                        if (_bol_Cargar_PartesEstados &&
                            g_mdl_MYT_Configuracion.idParteEstado_PorDefecto!=null)
                        {
                            ThreadStart obj_ThreadStart_PARTESESTADOS = new ThreadStart(Obtener_PartesEstados_Modelo);
                            Thread obj_Thread_PARTESESTADOS = new Thread(obj_ThreadStart_PARTESESTADOS);
                            obj_Thread_PARTESESTADOS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo[0] = true;
                        }

                        //MAE_Prioridades ##########################################################################################
                        if (_bol_Cargar_Prioridades &&
                            g_mdl_MYT_Configuracion.idPrioridad_PorDefecto!=null)
                        {
                            ThreadStart obj_ThreadStart_PRIORIDADES= new ThreadStart(Obtener_Prioridades_Modelo);
                            Thread obj_Thread_PRIORIDADES = new Thread(obj_ThreadStart_PRIORIDADES);
                            obj_Thread_PRIORIDADES.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo[1] = true;
                        }

                        //MYT_PartesTipos ##########################################################################################
                        if (_bol_Cargar_PartesTipos &&
                            g_mdl_MYT_Configuracion.idParteTipo_PorDefecto != null)
                        {
                            ThreadStart obj_ThreadStart_PARTETIPO = new ThreadStart(Obtener_ParteTipo_Modelo);
                            Thread obj_Thread_PARTETIPO = new Thread(obj_ThreadStart_PARTETIPO);
                            obj_Thread_PARTETIPO.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo[2] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_PartesEstados_Modelo()
        {
            try
            {
                MYT_PartesEstados_Datos obj_MYT_PartesEstados_Datos = new MYT_PartesEstados_Datos();
                g_mdl_MYT_Configuracion.MYT_PartesEstados = obj_MYT_PartesEstados_Datos.Obtener_Modelo_Por_Id(g_mdl_MYT_Configuracion.idParteEstado_PorDefecto.Value);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }
        private void Obtener_Prioridades_Modelo()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEPRIORIDADES_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_mdl_MYT_Configuracion.idPrioridad_PorDefecto.Value };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_mdl_MYT_Configuracion.MAE_Prioridades = (MAE_Prioridades)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[1] = true;
            }
        }
        private void Obtener_ParteTipo_Modelo()
        {
            try
            {
                MYT_PartesTipos_Datos obj_MYT_PartesTipos_Datos = new MYT_PartesTipos_Datos();
                g_mdl_MYT_Configuracion.MYT_PartesTipos = obj_MYT_PartesTipos_Datos.Obtener_Modelo_Por_Id(g_mdl_MYT_Configuracion.idParteTipo_PorDefecto.Value,false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[2] = true;
            }
        }
        #endregion
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MYT_Configuracion.id) + " , " +
                   nameof(MYT_Configuracion.idParteEstado_PorDefecto) + " , " +
                   nameof(MYT_Configuracion.idPrioridad_PorDefecto) + " , " +
                   nameof(MYT_Configuracion.idParteTipo_PorDefecto) + 
               " FROM " + nameof(MYT_Configuracion);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_Configuracion mdl_MYT_Configuracion_AGrabar = (MYT_Configuracion)_mdl_obj;
                MYT_Configuracion mdl_MYT_Configuracion_DatosViejos = new MYT_Configuracion();

                // Ver si existe ###################################################################### 
                MYT_Configuracion mdl_MYT_Configuracion_Final = Obtener_Modelo_Por_Id(mdl_MYT_Configuracion_AGrabar.id,false,false,false);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_Configuracion_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Configuracion_Final, mdl_MYT_Configuracion_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Configuracion_AGrabar, mdl_MYT_Configuracion_Final, false, false);

                    #region update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_Configuracion) +
                                           " SET " +
                                                nameof(MYT_Configuracion.idParteEstado_PorDefecto) + "=@idParteEstado_PorDefecto," +
                                                nameof(MYT_Configuracion.idPrioridad_PorDefecto) + "=@idPrioridad_PorDefecto, " +
                                                nameof(MYT_Configuracion.idParteTipo_PorDefecto) + "=@idParteTipo_PorDefecto " +
                                           " WHERE " +
                                               nameof(MYT_Configuracion.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_MYT_Configuracion_AGrabar.idParteEstado_PorDefecto!=null
                            ?   new SqlParameter("@idParteEstado_PorDefecto", mdl_MYT_Configuracion_AGrabar.idParteEstado_PorDefecto.Value)
                            :   new SqlParameter("@idParteEstado_PorDefecto",  DBNull.Value),
                        mdl_MYT_Configuracion_AGrabar.idPrioridad_PorDefecto!=null
                            ?   new SqlParameter("@idPrioridad_PorDefecto", mdl_MYT_Configuracion_AGrabar.idPrioridad_PorDefecto.Value)
                            :   new SqlParameter("@idPrioridad_PorDefecto",  DBNull.Value),
                        mdl_MYT_Configuracion_AGrabar.idParteTipo_PorDefecto!=null
                            ?   new SqlParameter("@idParteTipo_PorDefecto", mdl_MYT_Configuracion_AGrabar.idParteTipo_PorDefecto.Value)
                            :   new SqlParameter("@idParteTipo_PorDefecto",  DBNull.Value),
                        new SqlParameter("@id",  mdl_MYT_Configuracion_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_MYT_Configuracion_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MYT_Configuracion_Final = new MYT_Configuracion();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Configuracion_AGrabar, mdl_MYT_Configuracion_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_Configuracion) +
                                               " (" +
                                                        nameof(MYT_Configuracion.idParteEstado_PorDefecto) + "," +
                                                        nameof(MYT_Configuracion.idPrioridad_PorDefecto) + "," +
                                                        nameof(MYT_Configuracion.idParteTipo_PorDefecto) + 
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MYT_Configuracion.id) +
                                               " VALUES " +
                                               " ( " +
                                                    "@idParteEstado_PorDefecto," +
                                                    "@idPrioridad_PorDefecto," +
                                                    "@idParteTipo_PorDefecto" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        mdl_MYT_Configuracion_AGrabar.idParteEstado_PorDefecto!=null
                            ?   new SqlParameter("@idParteEstado_PorDefecto", mdl_MYT_Configuracion_AGrabar.idParteEstado_PorDefecto.Value)
                            :   new SqlParameter("@idParteEstado_PorDefecto",  DBNull.Value),
                        mdl_MYT_Configuracion_AGrabar.idPrioridad_PorDefecto!=null
                            ?   new SqlParameter("@idPrioridad_PorDefecto", mdl_MYT_Configuracion_AGrabar.idPrioridad_PorDefecto.Value)
                            :   new SqlParameter("@idPrioridad_PorDefecto",  DBNull.Value),
                        mdl_MYT_Configuracion_AGrabar.idParteTipo_PorDefecto!=null
                            ?   new SqlParameter("@idParteTipo_PorDefecto", mdl_MYT_Configuracion_AGrabar.idParteTipo_PorDefecto.Value)
                            :   new SqlParameter("@idParteTipo_PorDefecto",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Configuracion), mdl_MYT_Configuracion_DatosViejos, mdl_MYT_Configuracion_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MYT_Configuracion mdl_MYT_Configuracion_Final = Obtener_Modelo_Por_Id(_lng_id,false,false,false);
                //######################################################################################

                if (mdl_MYT_Configuracion_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM " + nameof(MYT_Configuracion) +
                                            " WHERE " +
                                              nameof(MYT_Configuracion.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Configuracion), null, mdl_MYT_Configuracion_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Configuracion_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
